<template>
  <v-container>
    <v-row justify="space-between">
      <v-col cols="5">
        <v-row justify="space-between">
          <v-col cols="6">
            <type-field
              :actions="actions"
              :label="label"
              :types="types"
            />
          </v-col>
          <v-col cols="6">
            <tag-field
              ref="tag"
              :actions="actions"
              :label="label"
              :field-label="$t('editor-bar.label.tag')"
              @keydown.native.ctrl.enter="onTagCtrlEnter"
            />
          </v-col>
        </v-row>
        <v-row justify="space-between">
          <v-col cols="4">
            <onset-field
              :actions="actions"
              :signature="signature"
              :label="label"
            />
          </v-col>
          <v-col cols="4">
            <duration-field
              :actions="actions"
              :signature="signature"
              :label="label"
            />
          </v-col>
          <v-col cols="4">
            <offset-field
              :actions="actions"
              :signature="signature"
              :label="label"
            />
          </v-col>
        </v-row>
      </v-col>
      <v-col cols="5">
        <comment-field
          :actions="actions"
          :label="label"
        />
      </v-col>
      <v-col cols="2">
        <dez-fab
          class="ma-5"
          color="warning"
          icon="mdi-delete"
          :tooltip="$t('editor-bar.tooltip.delete')"
          :disabled="label === null"
          @click="() => actions.deleteSelected(true, true)"
        />
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import {
  Vue, Component, Prop, Ref,
} from 'vue-property-decorator';
import type AnalysisActions from '@/logic/AnalysisActions';
import type {
  Duration, Label, Onset, Signature,
} from '@/data';
import { lineIds } from '@/data';
import DezFab from '@/vuejs/components/utils/DezFab.vue';
import OnsetField from './editor-fields/OnsetField.vue';
import DurationField from './editor-fields/DurationField.vue';
import OffsetField from './editor-fields/OffsetField.vue';
import TypeField from './editor-fields/TypeField.vue';
import TagField from './editor-fields/TagField.vue';
import CommentField from './editor-fields/CommentField.vue';

@Component({
  components: {
    OnsetField,
    DurationField,
    OffsetField,
    TypeField,
    TagField,
    CommentField,
    DezFab,
  },
})
export default class EditorBar extends Vue {
  @Prop({ default: null })
  label!: Label | null;

  @Prop({ required: true })
  actions!: AnalysisActions;

  @Prop({ required: true })
  signature!: Signature;

  @Prop()
  types!: string[];

  @Ref()
  tag!: TagField;

  public focus(): void {
    this.tag.focus();
  }

  /**
   * Clone the current selected label, and offset it by the duration
   */
  async onTagCtrlEnter(e: KeyboardEvent) {
    if (!this.label) return;
    const isFeedback = e.shiftKey;
    // Use duration of one in the case of bar label
    const clampedOffset = this.label.duration || 1 as Duration;

    const newOnset = isFeedback
      // If shift-ctrl, add label at the same position
      ? this.label.onset
      // before current one
      // ? (this.label.onset - clampedOffset) as Onset
      // else, add label after
      : (this.label.onset + clampedOffset) as Onset;

    const newType = isFeedback ? 'Feedback' : this.label.type;
    const newStaffId = isFeedback ? lineIds.top1 : this.label.staffId;

    // TODO: check that label is still in bounds
    // problem: no current definition for piece bounds

    // clone label, but using new onset
    const newLabelId = this.actions.createLabel();
    this.actions.updateLabel(newLabelId, 'onset', newOnset);
    this.actions.updateLabel(newLabelId, 'duration', this.label.duration);
    this.actions.updateLabel(newLabelId, 'durationType', this.label.durationType);
    this.actions.updateLabel(newLabelId, 'type', newType);
    this.actions.updateLabel(newLabelId, 'tag', this.label.tag);
    this.actions.updateLabel(newLabelId, 'staffId', newStaffId);
    this.actions.select(newLabelId, true);

    await Vue.nextTick();
    this.tag.focus();
  }
}
</script>
